#ifdef GL_ES
	#define LOWP lowp
	precision mediump float;
#else
	#define LOWP
#endif

varying vec4 v_color; 
varying vec2 v_texCoords; 
uniform sampler2D u_texture; 
uniform float distance;


uniform int u_lights;
uniform int u_use_texture;

// Whether if picking or not
uniform int u_picking;
uniform vec4 u_colorId;
uniform vec4 u_color;

varying vec3 normal, eyeVec;
varying vec4 vert_color;

uniform float u_time;

	
float getDistMult() {
	float res = 1.0;
	
	if(distance < 1.0) {
		res = distance;
	}
	
	return res;
}	

vec4 getToonColor()
{
	vec4 final_color = vec4(0.0, 0.0, 0.0, 1.0);

	vec3 N = normalize(normal);
	vec3 L = eyeVec;
		
	float intensity = dot(N, L);
	
	if (intensity > 0.95)
		{
			final_color = vec4(1.0, 1.0, 1.0, 1.0);
		}
		else if (intensity > 0.5)
		{
			final_color = vec4(0.6, 0.6, 0.6, 1.0);
		}
		else if (intensity > 0.25)
		{
			final_color = vec4(0.3, 0.3, 0.3, 1.0);
		}
		else
		{
			final_color = vec4(0.2, 0.2, 0.2, 1.0);
		}
	
	return final_color;
}


vec4 getPhongColor()
{
	vec4 final_color = vec4(0.0, 0.0, 0.0, 1.0);

	vec3 N = normalize(normal);
	int i;
	for (i = 0; i < 1; ++i)
	{
		vec3 L = normalize(eyeVec);
		float lambertTerm = dot(N,L);
				
		if (lambertTerm > 0.0)
		{
			final_color += (vec4(1.0, 1.0, 1.0, 1.0) *  lambertTerm);

			vec3 E = normalize(eyeVec);
			vec3 R = reflect(-L, N);

			float shin = 30.0; 

			if(shin > 0.0)
			{
			    float specular = pow(max(dot(E,R), 0.0), shin);
			    final_color += (vec4(1.0, 0.8, 0.8, 1.0) * specular);
			}
			else
			{
			}
   		}
	}

	return final_color;
}

	
void main()
{ 
	gl_FragColor = getPhongColor() * u_color; 
}





